#include<iostream>
#include<iomanip>
using namespace std;

int main()
{
	//assume that we have to output
	int x5digits = 12345;
	
	//no formatting
	cout << "without any formatting\n";
	cout << x5digits << endl;
	
	//with extra spacing
	cout << "with extra spacing\n";
	cout << setw(10) << x5digits << endl;
	
	//with fill set to 0
	cout << "with extra spacing and fill set to 0\n";
	cout << setfill('0');
	cout << setw(10) << x5digits << endl;
	cout << setfill(' ');
	
	//with less spacing (simply ignored)
	cout << "with less spacing\n";
	cout << setw(3) << x5digits << endl;
	
	
	//and doubles
	double x5_2 = 123.45;
	//no formatting
	cout << "without any formatting\n";
	cout << x5_2 << endl;
	
	//with extra spacing
	cout << "with extra spacing\n";
	cout << setw(10) << x5_2 << endl;
	
	
	//with less spacing (simply ignored)
	cout << "with less spacing\n";
	cout << setw(3) << x5_2 << endl;
	
	
	system("pause");
	
	/* PROBLEM
	given an array of 9 integers (that all have values between 
	0 and 999) write a program that will display them in a 3x3 layout.
	So  even if the array is 9, 8, 7, 7, 6, 5, 5, 4, 3 the output will
	be something like
	
	9   8   7
	7   6   5
	5   4   3
	
	requirement columns must be separated by at least 2 spaces
	*/
	
	//here is the array
	int a[9] = {34, 999, 1, 654, 897, 0, 89, 33, 100};
	cout << "if I simply output the numbers with 2 spaces separating each column:\n";
	for (int i = 0 ; i < 9 ; i=i+3)
	{
		cout << a[i] << "  " << a[i+1] << "  " << a[i+2] << "\n";

	}
	
	cout << "the exact same code with setw(3) set:\n";
	for (int i = 0 ; i < 9 ; i++)
	{
		cout << setw(3) << a[i] << "  " << setw(3) << a[i+1] << "  " << setw(3) << a[i+2] << "\n";
		i+=2;
	}
	
	cout << "look at the same code but with setfill set to '.'\n";
	for (int i = 0 ; i < 9 ; i++)
	{
		cout << setfill('.');
		cout << setw(3) << a[i] << "  " << setw(3) << a[i+1] << "  " << setw(3) << a[i+2] << "\n";
		cout << setfill(' ');
		i+=2;
	}
	
	cout << "look at the same code but with setfill set to '0'\n";
	for (int i = 0 ; i < 9 ; i++)
	{
		cout << setfill('0');
		cout << setw(3) << a[i] << "  " << setw(3) << a[i+1] << "  " << setw(3) << a[i+2] << "\n";
		i+=2;
	}
	
}
